package com.zhongshu.reward.server.core.service;

import com.github.microservice.core.util.result.content.ResultContent;
import com.github.microservice.core.util.result.content.ResultState;
import com.zhongshu.reward.client.model.TransferRulerModel;
import com.zhongshu.reward.client.model.param.TransferRulerParam;
import com.zhongshu.reward.server.core.dao.TransferRulerDao;
import com.zhongshu.reward.server.core.domain.TransferRuler;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

/**
 * @author wjf
 * @date 2024/8/12
 */
@Service
public class TransferRulerService {

    @Autowired
    TransferRulerDao transferRulerDao;


    public Object saveOrUpdate(TransferRulerParam param){
        if (StringUtils.isNotEmpty(param.getId())){
            TransferRuler transferRuler = transferRulerDao.findTop1ById(param.getId());
            if (ObjectUtils.isEmpty(transferRuler)){
                return ResultContent.build(ResultState.Fail, "规则不存在");
            }
            BeanUtils.copyProperties(param, transferRuler);
            transferRulerDao.save(transferRuler);
            return ResultContent.buildContent(toModel(transferRuler));
        }else {
            List<TransferRuler> all = transferRulerDao.findAll();
            if (!all.isEmpty()){
                return ResultContent.build(ResultState.Fail, "已设置规则，请勿重复添加");
            }
            TransferRuler transferRuler = new TransferRuler();
            BeanUtils.copyProperties(param, transferRuler, "id");
            transferRulerDao.save(transferRuler);
            return ResultContent.buildContent(toModel(transferRuler));
        }
    }

    public Object getRuler(){
        List<TransferRuler> all = transferRulerDao.findAll(Example.of(TransferRuler.builder().build()));
        if (all.isEmpty()){
            return ResultContent.build(ResultState.Success);
        }
        return ResultContent.buildContent(toModel(all.get(0)));
    }

    TransferRulerModel toModel(TransferRuler transferRuler){
        TransferRulerModel model = new TransferRulerModel();
        if (ObjectUtils.isNotEmpty(transferRuler)){
            BeanUtils.copyProperties(transferRuler, model);
        }
        return model;
    }
}
